#!/usr/bin/env python
#coding:utf-8
from xml import sax
class TestHandler(sax.ContentHandler):            
    def __init__(self):                                
        self.r=[]
        
    def startDocument(self):      
        print "Document Start ..."
        
    def endDocument(self):         
        print "Document End ..."
        
    def startElement(self, name, attrs):
        self.chrs=''
        if name.lower()=='channel'.lower():
            self.tmp={}
        
    def endElement(self, name):
        if not hasattr( self,'tmp'):
            return
        if name.lower()=='channel'.lower():
            self.r.append( self.tmp)
        self.tmp[name.lower()]= self.chrs
        
    def characters(self, chrs):                           
        if hasattr( self,'tmp'):
            self.chrs += chrs

def decode(text, code=['utf8','gbk','gb2312']):
    out = ''
    for i in code:
        try:out = text.decode( i)
        except:pass
        else: break
    return out=='' and text or out

import os, user, re
def test():   
    f = os.path.join( user.home, '.pplive', 'pplive.list')
    if os.path.exists( f):
        txt = open( f).read()
    else:
        try:os.makedirs(os.path.join( user.home, '.pplive'))
        except:pass
        os.system('wget http://list.pplive.com/zh-cn/xml/new.xml -O %s'%f)
        txt = open( f).read()
    f = os.path.join( user.home, '.pplive', 'pplive.url')
    if not os.path.exists( f):
        t = open( f,'w+')
        l='''http://www.pplive.com/zh-cn/xml/default.xml
http://www.pplive.com/web/xml/newChannel.xml
http://www.pplive.com/zh-cn/xml/fenzhan.xml
http://www.pplive.com/zh-cn/xml/fz/vnet1.xml
http://www.pplive.com/zh-cn/xml/fz/wangtong.xml
http://www.pplive.com/zh-cn/xml/fz/default.xml
http://www.pplive.com/zh-cn/xml/all.xml
http://list.pplive.com/zh-cn/xml/new.xml
http://list.pplive.com/zh-cn/xml/default.xml
'''
        t.write(l)
        t.close()

    handler = TestHandler()   
    txt = decode( txt).encode('utf-8','ignore')
    txt = re.sub( r'gb2312', 'utf-8', txt, re.IGNORECASE)
    try:
        sax.parseString(txt,handler)
        r = handler.r
    except :
        return {}
    d ={}
    for i in r:
        if not i.has_key( 'catalog'):break
        if d.has_key( i['catalog']):d[ i['catalog']].append(i)
        else:d[ i['catalog']] = [i]
    return d
